import 'dart:io';

/// Abstract type that exposes a method to print to [stdout] some results
/// generated by the 'equations' library.
abstract class Output {
  /// This is to allow subtypes having a constant constructor too.
  const Output();

  /// Prints to the console, using [stdout], some examples of equations or
  /// systems of equations solved using various algorithms.
  void processOutput();
}
